/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.6
        Device            :  PIC18F87K22
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 2.30 and above
        MPLAB 	          :  MPLAB X 5.40	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

/**
  Section: Included Files
*/

#include <xc.h>

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set S1 aliases
#define S1_TRIS                 TRISAbits.TRISA0
#define S1_LAT                  LATAbits.LATA0
#define S1_PORT                 PORTAbits.RA0
#define S1_ANS                  ANCON0bits.ANSEL0
#define S1_SetHigh()            do { LATAbits.LATA0 = 1; } while(0)
#define S1_SetLow()             do { LATAbits.LATA0 = 0; } while(0)
#define S1_Toggle()             do { LATAbits.LATA0 = ~LATAbits.LATA0; } while(0)
#define S1_GetValue()           PORTAbits.RA0
#define S1_SetDigitalInput()    do { TRISAbits.TRISA0 = 1; } while(0)
#define S1_SetDigitalOutput()   do { TRISAbits.TRISA0 = 0; } while(0)
#define S1_SetAnalogMode()      do { ANCON0bits.ANSEL0 = 1; } while(0)
#define S1_SetDigitalMode()     do { ANCON0bits.ANSEL0 = 0; } while(0)

// get/set RB0 procedures
#define RB0_SetHigh()            do { LATBbits.LATB0 = 1; } while(0)
#define RB0_SetLow()             do { LATBbits.LATB0 = 0; } while(0)
#define RB0_Toggle()             do { LATBbits.LATB0 = ~LATBbits.LATB0; } while(0)
#define RB0_GetValue()              PORTBbits.RB0
#define RB0_SetDigitalInput()    do { TRISBbits.TRISB0 = 1; } while(0)
#define RB0_SetDigitalOutput()   do { TRISBbits.TRISB0 = 0; } while(0)

// get/set S3 aliases
#define S3_TRIS                 TRISCbits.TRISC0
#define S3_LAT                  LATCbits.LATC0
#define S3_PORT                 PORTCbits.RC0
#define S3_SetHigh()            do { LATCbits.LATC0 = 1; } while(0)
#define S3_SetLow()             do { LATCbits.LATC0 = 0; } while(0)
#define S3_Toggle()             do { LATCbits.LATC0 = ~LATCbits.LATC0; } while(0)
#define S3_GetValue()           PORTCbits.RC0
#define S3_SetDigitalInput()    do { TRISCbits.TRISC0 = 1; } while(0)
#define S3_SetDigitalOutput()   do { TRISCbits.TRISC0 = 0; } while(0)

// get/set S0 aliases
#define S0_TRIS                 TRISCbits.TRISC1
#define S0_LAT                  LATCbits.LATC1
#define S0_PORT                 PORTCbits.RC1
#define S0_SetHigh()            do { LATCbits.LATC1 = 1; } while(0)
#define S0_SetLow()             do { LATCbits.LATC1 = 0; } while(0)
#define S0_Toggle()             do { LATCbits.LATC1 = ~LATCbits.LATC1; } while(0)
#define S0_GetValue()           PORTCbits.RC1
#define S0_SetDigitalInput()    do { TRISCbits.TRISC1 = 1; } while(0)
#define S0_SetDigitalOutput()   do { TRISCbits.TRISC1 = 0; } while(0)

// get/set RC6 procedures
#define RC6_SetHigh()            do { LATCbits.LATC6 = 1; } while(0)
#define RC6_SetLow()             do { LATCbits.LATC6 = 0; } while(0)
#define RC6_Toggle()             do { LATCbits.LATC6 = ~LATCbits.LATC6; } while(0)
#define RC6_GetValue()              PORTCbits.RC6
#define RC6_SetDigitalInput()    do { TRISCbits.TRISC6 = 1; } while(0)
#define RC6_SetDigitalOutput()   do { TRISCbits.TRISC6 = 0; } while(0)

// get/set RC7 procedures
#define RC7_SetHigh()            do { LATCbits.LATC7 = 1; } while(0)
#define RC7_SetLow()             do { LATCbits.LATC7 = 0; } while(0)
#define RC7_Toggle()             do { LATCbits.LATC7 = ~LATCbits.LATC7; } while(0)
#define RC7_GetValue()              PORTCbits.RC7
#define RC7_SetDigitalInput()    do { TRISCbits.TRISC7 = 1; } while(0)
#define RC7_SetDigitalOutput()   do { TRISCbits.TRISC7 = 0; } while(0)

// get/set S2 aliases
#define S2_TRIS                 TRISEbits.TRISE0
#define S2_LAT                  LATEbits.LATE0
#define S2_PORT                 PORTEbits.RE0
#define S2_SetHigh()            do { LATEbits.LATE0 = 1; } while(0)
#define S2_SetLow()             do { LATEbits.LATE0 = 0; } while(0)
#define S2_Toggle()             do { LATEbits.LATE0 = ~LATEbits.LATE0; } while(0)
#define S2_GetValue()           PORTEbits.RE0
#define S2_SetDigitalInput()    do { TRISEbits.TRISE0 = 1; } while(0)
#define S2_SetDigitalOutput()   do { TRISEbits.TRISE0 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/